import React, {useState, useEffect, useRef} from 'react';
import List from '@mui/material/List';
import ListItem from '@mui/material/ListItem';
import ListItemText from '@mui/material/ListItemText';
import ListItemAvatar from '@mui/material/ListItemAvatar';
import Box from '@mui/material/Box';

import {Link} from 'react-router-dom'

import { FloatBtn, ChatAvatar } from "../components"
import { connect }  from 'react-redux'

const selectedChat = {
  color: "#fff",
  backgroundColor: "#1976d2dd" 
}

const notSelectedChat = {
  color: "#1976d2",
  backgroundColor: "#fff"
}


const Chat = ({ chat, currChat }) => {

  const [msgText, setMsgText] = useState( chat.messages && chat.messages[0]?.text || 'нема')

  // const {_id, title, owner, members, messages} = chat
  // const { text, owner: msgOwner, media, createdAt } = messages

  useEffect(() => {
    setMsgText( chat.messages && chat.messages[0]?.text || 'нема')
  }, [chat])

  return (
    <Link 
      style={{ textDecoration: 'none' }}
      to={`/main/${chat._id}`}
      >
      <ListItem 
        className="chatItem"
        style={ currChat ? selectedChat : notSelectedChat }
        
        >
        <ListItemAvatar>
          <ChatAvatar chat={chat} />
        </ListItemAvatar>
        <ListItemText 
          primary={chat.title} 
          secondary={msgText} />
      </ListItem>

      {/* <div
        style={ currChat ? selectedChat : notSelectedChat }
        >
          <strong>
            {chat.title}
          </strong>         
          <div>
            {msgText}
          </div>
          
      </div> */}
    </Link>
  )
}

const ChatList = ({ chats=[], currChatId }) => {

  // const [chatsInput, setChats] = useState(chats)

  // useEffect(() => {
  //   setChats(chats)
  // }, [chats])

  return (
      <List        
        sx={{ width: '100%', bgcolor: 'background.paper', position: 'relative', zIndex: 2, }}
        >
          <div>
            <Box sx={{  position: 'fixed', top: '90%', left: '25%', zIndex: 10}} >
              <FloatBtn />
            </Box>

              {chats.map(chat =>          
                    <Chat key={chat._id} chat={chat} currChat={currChatId === chat._id} /> 
              )}  
          </div>  
        </List>

    
      
  )
}
export const CChatList = connect( state => ({ chats: Object.values(state.chats).filter(el => !!el._id)}))(ChatList)


