import React, {useState, useEffect, useRef} from 'react';

import { connect }  from 'react-redux'
import {
  actionFullChatList,
} from "../actions"

import { CChatList } from '../components'

const chatsPage= {
   height: "calc(100vh - 60px)",
   overflowY: "auto"
 }

const ChatsPage = ({ match:{params:{_id}}, auth, getChats, chatsCount=20 }) => {
   const [chatBlock, setChatBlock] = useState(0)
 
   useEffect(async () => {
     const userId = auth.payload?.sub?.id 
     if (userId) {
      await getChats(userId, chatBlock, chatsCount)
     } 
     return function cleanUp() {
       
     }
   },[chatBlock])
 
   return (
     <div 
       style={chatsPage}
       onScroll={(e) => {
          if (e.target.scrollTop >= e.target.scrollHeight - e.target.clientHeight) {
            setChatBlock(chatBlock => chatBlock + chatsCount)
          }
       }}
       >

         <CChatList currChatId={_id} />

     </div>
   )
 }
 export const CChatsPage= connect( state => ({ auth: state.auth }),
                                          { getChats: actionFullChatList
                                                })(ChatsPage)